﻿/*
* XML2 by Grant Skinner. Feb 27, 2004
* Visit www.gskinner.com for documentation, updates and more free code.
*
* You may distribute this code freely, as long as this comment block remains intact.
*/

import mx.events.EventDispatcher;

class com.gskinner.net.XML2 extends XML {
// define public properties:
	var timeout:Number = 7000;
	
// define private properties:
	private var tmp_timeoutID:Number;
	
// define functions for EventDispatcher:
	private var dispatchEvent:Function;
	var addEventListener:Function;
	var removeEventListener:Function;
	
// initialization:
	function XML2(p_xml:String) {
		super(p_xml);
		EventDispatcher.initialize(this);
	}
	
// public methods:
	function load(p_url):Void {
		setTimeout();
		super.load(p_url);
	}
	
	function sendAndLoad(p_url:String,p_targetXML:XML):Void {
		setTimeout();
		super.sendAndLoad(p_url,p_targetXML);
	}
	
// private methods:
	private function setTimeout():Void {
		clearTimeout();
		tmp_timeoutID = setInterval(this,"onTimeout",timeout);
	}
	
	private function clearTimeout():Void {
		clearInterval(tmp_timeoutID);
		delete(tmp_timeoutID);
	}
	
	private function onLoad(p_success):Void {
		if (!tmp_timeoutID) { return; }
		clearTimeout();
		dispatchEvent({target:this,type:"load",success:p_success});
	}
	
	private function onTimeout():Void {
		clearTimeout();
		status = -100;
		dispatchEvent({target:this,type:"load",success:false});
	}
}